// To parse this JSON data, do
//
//     final orderModel = orderModelFromMap(jsonString);

import 'dart:convert';

OrderModel orderModelFromMap(String str) => OrderModel.fromMap(json.decode(str));

String orderModelToMap(OrderModel data) => json.encode(data.toMap());

class OrderModel {
    OrderModel({
        this.status,
        this.code,
        this.timestamp,
        this.data,
    });

    String? status;
    int? code;
    String? timestamp;
    Data? data;

    factory OrderModel.fromMap(Map<String, dynamic> json) => OrderModel(
        status: json["status"],
        code: json["code"],
        timestamp: json["timestamp"],
        data: json["data"] == null ? null : Data.fromMap(json["data"]),
    );

    Map<String, dynamic> toMap() => {
        "status": status,
        "code": code,
        "timestamp": timestamp,
        "data": data?.toMap(),
    };
}

class Data {
    Data({
        this.isFirstPage,
        this.totalElements,
        this.totalPages,
        this.isLastPage,
        this.content,
        this.currentPage,
        this.pageSize,
    });

    bool? isFirstPage;
    int? totalElements;
    int? totalPages;
    bool? isLastPage;
    List<Content>? content;
    int? currentPage;
    int? pageSize;

    factory Data.fromMap(Map<String, dynamic> json) => Data(
        isFirstPage: json["is_first_page"],
        totalElements: json["total_elements"],
        totalPages: json["total_pages"],
        isLastPage: json["is_last_page"],
        content: json["content"] == null ? [] : List<Content>.from(json["content"]!.map((x) => Content.fromMap(x))),
        currentPage: json["current_page"],
        pageSize: json["page_size"],
    );

    Map<String, dynamic> toMap() => {
        "is_first_page": isFirstPage,
        "total_elements": totalElements,
        "total_pages": totalPages,
        "is_last_page": isLastPage,
        "content": content == null ? [] : List<dynamic>.from(content!.map((x) => x.toMap())),
        "current_page": currentPage,
        "page_size": pageSize,
    };
}

class Content {
    Content({
        this.createdAt,
        this.updatedAt,
        this.userId,
        this.id,
        this.reference,
        this.orderDesc,
        this.couponCode,
        this.platform,
        this.currencyName,
        this.currencyCode,
        this.deliveryAddress,
        this.totalQty,
        this.total,
        this.subtotal,
        this.totalDiscount,
        this.totalPaid,
        this.balance,
        this.totalMargin,
        this.deliveryCharge,
        this.vat,
        this.status,
        this.offlineSale,
        this.manualSale,
        this.dateSynced,
        this.viewed,
        this.items,
        this.channel,
        this.customer,
        this.staff,
        this.delivery,
    });

    String? createdAt;
    String? updatedAt;
    dynamic userId;
    int? id;
    String? reference;
    String? orderDesc;
    dynamic couponCode;
    dynamic platform;
    dynamic currencyName;
    String? currencyCode;
    dynamic deliveryAddress;
    dynamic? totalQty;
    dynamic? total;
    dynamic? subtotal;
    dynamic? totalDiscount;
    dynamic? totalPaid;
    dynamic? balance;
    dynamic? totalMargin;
    dynamic? deliveryCharge;
    dynamic? vat;
    String? status;
    bool? offlineSale;
    bool? manualSale;
    String? dateSynced;
    bool? viewed;
    List<Item>? items;
    dynamic channel;
    Customer? customer;
    dynamic staff;
    Delivery? delivery;

    factory Content.fromMap(Map<String, dynamic> json) => Content(
        createdAt: json["createdAt"],
        updatedAt: json["updatedAt"],
        userId: json["userId"],
        id: json["id"],
        reference: json["reference"],
        orderDesc: json["order_desc"],
        couponCode: json["coupon_code"],
        platform: json["platform"],
        currencyName: json["currency_name"],
        currencyCode: json["currency_code"],
        deliveryAddress: json["delivery_address"],
        totalQty: json["total_qty"],
        total: json["total"],
        subtotal: json["subtotal"],
        totalDiscount: json["total_discount"],
        totalPaid: json["total_paid"],
        balance: json["balance"],
        totalMargin: json["total_margin"],
        deliveryCharge: json["delivery_charge"],
        vat: json["vat"],
        status: json["status"],
        offlineSale: json["offline_sale"],
        manualSale: json["manual_sale"],
        dateSynced: json["date_synced"],
        viewed: json["viewed"],
        items: json["items"] == null ? [] : List<Item>.from(json["items"]!.map((x) => Item.fromMap(x))),
        channel: json["channel"],
        customer: json["customer"] == null ? null : Customer.fromMap(json["customer"]),
        staff: json["staff"],
        delivery: json["delivery"] == null ? null : Delivery.fromMap(json["delivery"]),
    );

    Map<String, dynamic> toMap() => {
        "createdAt": createdAt,
        "updatedAt": updatedAt,
        "userId": userId,
        "id": id,
        "reference": reference,
        "order_desc": orderDesc,
        "coupon_code": couponCode,
        "platform": platform,
        "currency_name": currencyName,
        "currency_code": currencyCode,
        "delivery_address": deliveryAddress,
        "total_qty": totalQty,
        "total": total,
        "subtotal": subtotal,
        "total_discount": totalDiscount,
        "total_paid": totalPaid,
        "balance": balance,
        "total_margin": totalMargin,
        "delivery_charge": deliveryCharge,
        "vat": vat,
        "status": status,
        "offline_sale": offlineSale,
        "manual_sale": manualSale,
        "date_synced": dateSynced,
        "viewed": viewed,
        "items": items == null ? [] : List<dynamic>.from(items!.map((x) => x.toMap())),
        "channel": channel,
        "customer": customer?.toMap(),
        "staff": staff,
        "delivery": delivery?.toMap(),
    };
}

class Customer {
    Customer({
        this.id,
        this.firstName,
        this.lastName,
        this.email,
        this.phone,
        this.mediaKey,
        this.baseUrl,
        this.groups,
    });

    int? id;
    dynamic firstName;
    dynamic lastName;
    String? email;
    String? phone;
    dynamic mediaKey;
    dynamic baseUrl;
    dynamic groups;

    factory Customer.fromMap(Map<String, dynamic> json) => Customer(
        id: json["id"],
        firstName: json["first_name"],
        lastName: json["last_name"],
        email: json["email"],
        phone: json["phone"],
        mediaKey: json["media_key"],
        baseUrl: json["base_url"],
        groups: json["groups"],
    );

    Map<String, dynamic> toMap() => {
        "id": id,
        "first_name": firstName,
        "last_name": lastName,
        "email": email,
        "phone": phone,
        "media_key": mediaKey,
        "base_url": baseUrl,
        "groups": groups,
    };
}

class Delivery {
    Delivery({
        this.firstName,
        this.lastName,
        this.phone,
        this.email,
        this.address,
        this.city,
        this.state,
        this.postCode,
        this.landmark,
        this.googlePlaceId,
        this.googleMapSearchPayload,
    });

    String? firstName;
    String? lastName;
    String? phone;
    String? email;
    String? address;
    String? city;
    String? state;
    String? postCode;
    String? landmark;
    dynamic googlePlaceId;
    dynamic googleMapSearchPayload;

    factory Delivery.fromMap(Map<String, dynamic> json) => Delivery(
        firstName: json["first_name"],
        lastName: json["last_name"],
        phone: json["phone"],
        email: json["email"],
        address: json["address"],
        city: json["city"],
        state: json["state"],
        postCode: json["post_code"],
        landmark: json["landmark"],
        googlePlaceId: json["google_place_id"],
        googleMapSearchPayload: json["google_map_search_payload"],
    );

    Map<String, dynamic> toMap() => {
        "first_name": firstName,
        "last_name": lastName,
        "phone": phone,
        "email": email,
        "address": address,
        "city": city,
        "state": state,
        "post_code": postCode,
        "landmark": landmark,
        "google_place_id": googlePlaceId,
        "google_map_search_payload": googleMapSearchPayload,
    };
}

class Item {
    Item({
        this.id,
        this.productName,
        this.productImage,
        this.productCode,
        this.productBarcode,
        this.combinationName,
        this.price,
        this.qty,
        this.vat,
        this.vatExempted,
        this.supplierPrice,
        this.margin,
        this.isSubscription,
        this.itemVariants,
        this.thumbnail,
        this.medium,
    });

    int? id;
    String? productName;
    String? productImage;
    String? productCode;
    String? productBarcode;
    String? combinationName;
    dynamic? price;
    dynamic? qty;
    dynamic? vat;
    bool? vatExempted;
    dynamic supplierPrice;
    dynamic? margin;
    bool? isSubscription;
    List<ItemVariant>? itemVariants;
    String? thumbnail;
    String? medium;

    factory Item.fromMap(Map<String, dynamic> json) => Item(
        id: json["id"],
        productName: json["product_name"],
        productImage: json["product_image"],
        productCode: json["product_code"],
        productBarcode: json["product_barcode"],
        combinationName: json["combination_name"],
        price: json["price"],
        qty: json["qty"],
        vat: json["vat"],
        vatExempted: json["vat_exempted"],
        supplierPrice: json["supplier_price"],
        margin: json["margin"],
        isSubscription: json["is_subscription"],
        itemVariants: json["item_variants"] == null ? [] : List<ItemVariant>.from(json["item_variants"]!.map((x) => ItemVariant.fromMap(x))),
        thumbnail: json["thumbnail"],
        medium: json["medium"],
    );

    Map<String, dynamic> toMap() => {
        "id": id,
        "product_name": productName,
        "product_image": productImage,
        "product_code": productCode,
        "product_barcode": productBarcode,
        "combination_name": combinationName,
        "price": price,
        "qty": qty,
        "vat": vat,
        "vat_exempted": vatExempted,
        "supplier_price": supplierPrice,
        "margin": margin,
        "is_subscription": isSubscription,
        "item_variants": itemVariants == null ? [] : List<dynamic>.from(itemVariants!.map((x) => x.toMap())),
        "thumbnail": thumbnail,
        "medium": medium,
    };
}

class ItemVariant {
    ItemVariant({
        this.variantName,
        this.entryValue,
    });

    String? variantName;
    String? entryValue;

    factory ItemVariant.fromMap(Map<String, dynamic> json) => ItemVariant(
        variantName: json["variant_name"],
        entryValue: json["entry_value"],
    );

    Map<String, dynamic> toMap() => {
        "variant_name": variantName,
        "entry_value": entryValue,
    };
}
