// To parse this JSON data, do
//
//     final singleProductModel = singleProductModelFromMap(jsonString);

import 'dart:convert';

SingleProductModel singleProductModelFromMap(String str) => SingleProductModel.fromMap(json.decode(str));

String singleProductModelToMap(SingleProductModel data) => json.encode(data.toMap());

class SingleProductModel {
  SingleProductModel({
    this.status,
    this.code,
    this.message,
    this.timestamp,
    this.data,
  });

  String? status;
  int? code;
  String? message;
  String? timestamp;
  Data? data;

  factory SingleProductModel.fromMap(Map<String, dynamic> json) => SingleProductModel(
    status: json["status"],
    code: json["code"],
    message: json["message"],
    timestamp: json["timestamp"],
    data: json["data"] == null ? null : Data.fromMap(json["data"]),
  );

  Map<String, dynamic> toMap() => {
    "status": status,
    "code": code,
    "message": message,
    "timestamp": timestamp,
    "data": data?.toMap(),
  };
}

class Data {
  Data({
    this.pricing,
    this.inventory,
    this.extra,
    this.id,
    this.title,
    this.slug,
    this.code,
    this.gender,
    this.description,
    this.createdAt,
    this.specifications,
    this.updatedAt,
    this.freeDelivery,
    this.exemptVat,
    this.hasVariants,
    this.checkoutMessage,
    this.demoLink,
    this.demoLinkType,
    this.ageGroup,
    this.seoUrl,
    this.shortUrl,
    this.seoDesc,
    this.seoTags,
    this.seoTitle,
    this.tags,
    this.shippingDurationMax,
    this.shippingDurationMetric,
    this.shippingRequired,
    this.shippingDurationMin,
    this.weight,
    this.price,
    this.qty,
    this.weightUnit,
    this.status,
    this.mainImageId,
    this.hasExpiry,
    this.expiryDate,
    this.manufacturingDate,
    this.productTypeCode,
    this.maxBillingCount,
    this.billingCycle,
    this.categoryId,
    this.brandId,
    this.warehouseId,
    this.supplierId,
    this.images,
    this.variants,
    this.variantCombinations,
    this.isDefault,
    this.shareLinks,
    this.relatedProducts,
    this.productType,
    this.category,
    this.brand,
    this.supplier,
    this.collections,
    this.salesChannels,
    this.downloadables,
    this.warehouse,
    this.mediumImageUrl,
    this.thumbnailImageUrl,
  });

  Pricing? pricing;
  Inventory? inventory;
  bool? extra;
  int? id;
  String? title;
  String? slug;
  dynamic? code;
  dynamic gender;
  String? description;
  String? createdAt;
  dynamic specifications;
  String? updatedAt;
  dynamic freeDelivery;
  bool? exemptVat;
  bool? hasVariants;
  String? checkoutMessage;
  String? demoLink;
  String? demoLinkType;
  dynamic ageGroup;
  dynamic seoUrl;
  dynamic shortUrl;
  String? seoDesc;
  dynamic seoTags;
  String? seoTitle;
  dynamic tags;
  int? shippingDurationMax;
  String? shippingDurationMetric;
  dynamic shippingRequired;
  dynamic? shippingDurationMin;
  dynamic? weight;
  dynamic? price;
  int? qty;
  String? weightUnit;
  String? status;
  int? mainImageId;
  bool? hasExpiry;
  dynamic expiryDate;
  dynamic manufacturingDate;
  String? productTypeCode;
  int? maxBillingCount;
  dynamic billingCycle;
  int? categoryId;
  int? brandId;
  dynamic warehouseId;
  dynamic supplierId;
  List<Image>? images;
  List<Variant>? variants;
  List<VariantCombination>? variantCombinations;
  bool? isDefault;
  dynamic shareLinks;
  dynamic relatedProducts;
  dynamic productType;
  dynamic category;
  dynamic brand;
  dynamic supplier;
  List<dynamic>? collections;
  List<dynamic>? salesChannels;
  List<dynamic>? downloadables;
  dynamic warehouse;
  String? mediumImageUrl;
  String? thumbnailImageUrl;

  factory Data.fromMap(Map<String, dynamic> json) => Data(
    pricing: json["pricing"] == null ? null : Pricing.fromMap(json["pricing"]),
    inventory: json["inventory"] == null ? null : Inventory.fromMap(json["inventory"]),
    extra: json["extra"],
    id: json["id"],
    title: json["title"],
    slug: json["slug"],
    code: json["code"],
    gender: json["gender"],
    description: json["description"],
    createdAt: json["created_at"],
    specifications: json["specifications"],
    updatedAt: json["updated_at"],
    freeDelivery: json["free_delivery"],
    exemptVat: json["exempt_vat"],
    hasVariants: json["has_variants"],
    checkoutMessage: json["checkout_message"],
    demoLink: json["demo_link"],
    demoLinkType: json["demo_link_type"],
    ageGroup: json["age_group"],
    seoUrl: json["seo_url"],
    shortUrl: json["short_url"],
    seoDesc: json["seo_desc"],
    seoTags: json["seo_tags"],
    seoTitle: json["seo_title"],
    tags: json["tags"],
    shippingDurationMax: json["shipping_duration_max"],
    shippingDurationMetric: json["shipping_duration_metric"],
    shippingRequired: json["shipping_required"],
    shippingDurationMin: json["shipping_duration_min"],
    weight: json["weight"],
    price: json["price"],
    qty: json["qty"],
    weightUnit: json["weight_unit"],
    status: json["status"],
    mainImageId: json["main_image_id"],
    hasExpiry: json["has_expiry"],
    expiryDate: json["expiry_date"],
    manufacturingDate: json["manufacturing_date"],
    productTypeCode: json["product_type_code"],
    maxBillingCount: json["max_billing_count"],
    billingCycle: json["billing_cycle"],
    categoryId: json["category_id"],
    brandId: json["brand_id"],
    warehouseId: json["warehouse_id"],
    supplierId: json["supplier_id"],
    images: json["images"] == null ? [] : List<Image>.from(json["images"]!.map((x) => Image.fromMap(x))),
    variants: json["variants"] == null ? [] : List<Variant>.from(json["variants"]!.map((x) => Variant.fromMap(x))),
    variantCombinations: json["variant_combinations"] == null ? [] : List<VariantCombination>.from(json["variant_combinations"]!.map((x) => VariantCombination.fromMap(x))),
    isDefault: json["is_default"],
    shareLinks: json["share_links"],
    relatedProducts: json["related_products"],
    productType: json["product_type"],
    category: json["category"],
    brand: json["brand"],
    supplier: json["supplier"],
    collections: json["collections"] == null ? [] : List<dynamic>.from(json["collections"]!.map((x) => x)),
    salesChannels: json["sales_channels"] == null ? [] : List<dynamic>.from(json["sales_channels"]!.map((x) => x)),
    downloadables: json["downloadables"] == null ? [] : List<dynamic>.from(json["downloadables"]!.map((x) => x)),
    warehouse: json["warehouse"],
    mediumImageUrl: json["medium_image_url"],
    thumbnailImageUrl: json["thumbnail_image_url"],
  );

  Map<String, dynamic> toMap() => {
    "pricing": pricing?.toMap(),
    "inventory": inventory?.toMap(),
    "extra": extra,
    "id": id,
    "title": title,
    "slug": slug,
    "code": code,
    "gender": gender,
    "description": description,
    "created_at": createdAt,
    "specifications": specifications,
    "updated_at": updatedAt,
    "free_delivery": freeDelivery,
    "exempt_vat": exemptVat,
    "has_variants": hasVariants,
    "checkout_message": checkoutMessage,
    "demo_link": demoLink,
    "demo_link_type": demoLinkType,
    "age_group": ageGroup,
    "seo_url": seoUrl,
    "short_url": shortUrl,
    "seo_desc": seoDesc,
    "seo_tags": seoTags,
    "seo_title": seoTitle,
    "tags": tags,
    "shipping_duration_max": shippingDurationMax,
    "shipping_duration_metric": shippingDurationMetric,
    "shipping_required": shippingRequired,
    "shipping_duration_min": shippingDurationMin,
    "weight": weight,
    "price": price,
    "qty": qty,
    "weight_unit": weightUnit,
    "status": status,
    "main_image_id": mainImageId,
    "has_expiry": hasExpiry,
    "expiry_date": expiryDate,
    "manufacturing_date": manufacturingDate,
    "product_type_code": productTypeCode,
    "max_billing_count": maxBillingCount,
    "billing_cycle": billingCycle,
    "category_id": categoryId,
    "brand_id": brandId,
    "warehouse_id": warehouseId,
    "supplier_id": supplierId,
    "images": images == null ? [] : List<dynamic>.from(images!.map((x) => x.toMap())),
    "variants": variants == null ? [] : List<dynamic>.from(variants!.map((x) => x.toMap())),
    "variant_combinations": variantCombinations == null ? [] : List<dynamic>.from(variantCombinations!.map((x) => x.toMap())),
    "is_default": isDefault,
    "share_links": shareLinks,
    "related_products": relatedProducts,
    "product_type": productType,
    "category": category,
    "brand": brand,
    "supplier": supplier,
    "collections": collections == null ? [] : List<dynamic>.from(collections!.map((x) => x)),
    "sales_channels": salesChannels == null ? [] : List<dynamic>.from(salesChannels!.map((x) => x)),
    "downloadables": downloadables == null ? [] : List<dynamic>.from(downloadables!.map((x) => x)),
    "warehouse": warehouse,
    "medium_image_url": mediumImageUrl,
    "thumbnail_image_url": thumbnailImageUrl,
  };
}

class Image {
  Image({
    this.hibernateLazyInitializer,
    this.baseUrl,
    this.mediaKey,
    this.thumbnail,
    this.medium,
  });

  HibernateLazyInitializer? hibernateLazyInitializer;
  String? baseUrl;
  String? mediaKey;
  String? thumbnail;
  String? medium;

  factory Image.fromMap(Map<String, dynamic> json) => Image(
    hibernateLazyInitializer: json["hibernateLazyInitializer"] == null ? null : HibernateLazyInitializer.fromMap(json["hibernateLazyInitializer"]),
    baseUrl: json["base_url"],
    mediaKey: json["media_key"],
    thumbnail: json["thumbnail"],
    medium: json["medium"],
  );

  Map<String, dynamic> toMap() => {
    "hibernateLazyInitializer": hibernateLazyInitializer?.toMap(),
    "base_url": baseUrl,
    "media_key": mediaKey,
    "thumbnail": thumbnail,
    "medium": medium,
  };
}

class HibernateLazyInitializer {
  HibernateLazyInitializer();

  factory HibernateLazyInitializer.fromMap(Map<String, dynamic> json) => HibernateLazyInitializer(
  );

  Map<String, dynamic> toMap() => {
  };
}

class Inventory {
  Inventory({
    this.sku,
    this.barcode,
    this.quantity,
    this.trackQuantity,
    this.reorderPoint,
  });

  String? sku;
  String? barcode;
  dynamic? quantity;
  dynamic trackQuantity;
  dynamic? reorderPoint;

  factory Inventory.fromMap(Map<String, dynamic> json) => Inventory(
    sku: json["sku"],
    barcode: json["barcode"],
    quantity: json["quantity"],
    trackQuantity: json["track_quantity"],
    reorderPoint: json["reorder_point"],
  );

  Map<String, dynamic> toMap() => {
    "sku": sku,
    "barcode": barcode,
    "quantity": quantity,
    "track_quantity": trackQuantity,
    "reorder_point": reorderPoint,
  };
}

class Pricing {
  Pricing({
    this.currentPrice,
    this.salesPrice,
    this.onSales,
    this.supplierPrice,
    this.markup,
  });

  dynamic? currentPrice;
  dynamic? salesPrice;
  bool? onSales;
  dynamic? supplierPrice;
  dynamic? markup;

  factory Pricing.fromMap(Map<String, dynamic> json) => Pricing(
    currentPrice: json["current_price"],
    salesPrice: json["sales_price"],
    onSales: json["on_sales"],
    supplierPrice: json["supplier_price"],
    markup: json["markup"],
  );

  Map<String, dynamic> toMap() => {
    "current_price": currentPrice,
    "sales_price": salesPrice,
    "on_sales": onSales,
    "supplier_price": supplierPrice,
    "markup": markup,
  };
}

class VariantCombination {
  VariantCombination({
    this.id,
    this.name,
    this.code,
    this.currentPrice,
    this.salesPrice,
    this.onSales,
    this.supplierPrice,
    this.markup,
    this.sku,
    this.barcode,
    this.quantity,
    this.trackQuantity,
    this.reorderPoint,
    this.active,
    this.isSubscription,
    this.maxBillingCount,
    this.billingCycle,
    this.isDefault,
  });

  int? id;
  String? name;
  dynamic code;
  dynamic? currentPrice;
  dynamic? salesPrice;
  bool? onSales;
  dynamic? supplierPrice;
  dynamic? markup;
  String? sku;
  String? barcode;
  dynamic? quantity;
  bool? trackQuantity;
  dynamic? reorderPoint;
  bool? active;
  bool? isSubscription;
  dynamic maxBillingCount;
  dynamic billingCycle;
  bool? isDefault;

  factory VariantCombination.fromMap(Map<String, dynamic> json) => VariantCombination(
    id: json["id"],
    name: json["name"],
    code: json["code"],
    currentPrice: json["current_price"],
    salesPrice: json["sales_price"],
    onSales: json["on_sales"],
    supplierPrice: json["supplier_price"],
    markup: json["markup"],
    sku: json["sku"],
    barcode: json["barcode"],
    quantity: json["quantity"],
    trackQuantity: json["track_quantity"],
    reorderPoint: json["reorder_point"],
    active: json["active"],
    isSubscription: json["is_subscription"],
    maxBillingCount: json["max_billing_count"],
    billingCycle: json["billing_cycle"],
    isDefault: json["is_default"],
  );

  Map<String, dynamic> toMap() => {
    "id": id,
    "name": name,
    "code": code,
    "current_price": currentPrice,
    "sales_price": salesPrice,
    "on_sales": onSales,
    "supplier_price": supplierPrice,
    "markup": markup,
    "sku": sku,
    "barcode": barcode,
    "quantity": quantity,
    "track_quantity": trackQuantity,
    "reorder_point": reorderPoint,
    "active": active,
    "is_subscription": isSubscription,
    "max_billing_count": maxBillingCount,
    "billing_cycle": billingCycle,
    "is_default": isDefault,
  };
}

class Variant {
  Variant({
    this.id,
    this.name,
    this.code,
    this.slug,
    this.active,
    this.isDefault,
    this.options,
  });

  int? id;
  String? name;
  dynamic code;
  String? slug;
  bool? active;
  bool? isDefault;
  List<String>? options;

  factory Variant.fromMap(Map<String, dynamic> json) => Variant(
    id: json["id"],
    name: json["name"],
    code: json["code"],
    slug: json["slug"],
    active: json["active"],
    isDefault: json["is_default"],
    options: json["options"] == null ? [] : List<String>.from(json["options"]!.map((x) => x)),
  );

  Map<String, dynamic> toMap() => {
    "id": id,
    "name": name,
    "code": code,
    "slug": slug,
    "active": active,
    "is_default": isDefault,
    "options": options == null ? [] : List<dynamic>.from(options!.map((x) => x)),
  };
}
