import 'package:flutter/material.dart';
import 'package:intl/intl.dart';
import 'package:storebounty_account/common/styles/colors.dart';
import 'package:storebounty_account/common/styles/textstles.dart';
import 'package:storebounty_account/widget/constants/constant.dart';


class ReceivedChat extends StatelessWidget {
  final dynamic message;
  final Color? defaultColor;
  const ReceivedChat({Key? key, this.message, this.defaultColor}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    var msg = "${message?['message']?.replaceAll("\\n", "\n")}";
    return Container(
          margin: EdgeInsets.symmetric(horizontal: 14, vertical: 10),
          constraints: BoxConstraints(
              minWidth: 10, maxWidth: (MediaQuery.of(context).size.width - 100)),
          child: Row(
            mainAxisAlignment: MainAxisAlignment.start,
            crossAxisAlignment: CrossAxisAlignment.start,
            mainAxisSize: MainAxisSize.min,
            children: [
              Container(
                child: Container(
                  height: 26,
                  width: 26,
                  decoration: BoxDecoration(
                      image: DecorationImage(image: NetworkImage(message?['sender']?['avatarUrl'] ?? "${defaultImage}")),
                      color: defaultColor ?? AppColors.black, shape: BoxShape.circle),
                ),
              ),
              SizedBox(
                width: 10,
              ),
              Container(
                // constraints: BoxConstraints(
                //     minWidth: 10,
                //     maxWidth: (MediaQuery.of(context).size.width - 100)),
                child: Padding(
                  padding: EdgeInsets.all(16.0),
                  child: Column(
                    mainAxisAlignment: MainAxisAlignment.end,
                    crossAxisAlignment: CrossAxisAlignment.end,
                    children: [
                      Container(
                        constraints: BoxConstraints(
                            minWidth: 10,
                            maxWidth: (MediaQuery.of(context).size.width - 150)),
                        child: Text("$msg"),
                      ),
                      Row(
                        // mainAxisAlignment: MainAxisAlignment.start,
                        children: [
                          Text(
                            "${DateFormat.jm().format(DateTime.parse(message?['createdAt']))}",
                            style: Styles.p3(
                                fontSize: 9, color: Colors.black.withOpacity(0.5)),
                          ),
                        ],
                      )
                    ],
                  ),
                ),
                decoration: BoxDecoration(
                  color: Color(0xffF9FBFE),
                  borderRadius: BorderRadius.circular(12),
                ),
              ),
              SizedBox(
                width: 38,
              )
            ],
          ),
        );
    ;
  }
}
