import 'package:flutter/material.dart';
import 'package:intl/intl.dart';
import 'package:storebounty_account/common/styles/textstles.dart';

class SentChat extends StatelessWidget {
  final dynamic message;
  const SentChat({Key? key, this.message}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    var msg = "${message?['message']?.replaceAll("\\n", "\n").replaceAll("\\t", "\t")}";
    var msgType = message?['channelType'].toString().toLowerCase();
    return Container(
      margin: EdgeInsets.symmetric(horizontal: 14, vertical: 10),
      constraints: BoxConstraints(
          minWidth: 10,
          maxWidth: (MediaQuery.of(context).size.width - 40)),
      child: Row(
        mainAxisSize: MainAxisSize.min,
        mainAxisAlignment: MainAxisAlignment.end,
        children: [
          SizedBox(width: 40,),
          Container(
            child: Padding(
              padding: EdgeInsets.all(16.0),
              child: Column(
                mainAxisAlignment: MainAxisAlignment.end,
                crossAxisAlignment: CrossAxisAlignment.end,
                children: [
                  Container(
                    constraints: BoxConstraints(
                        minWidth: 10,
                        maxWidth: (MediaQuery.of(context).size.width - 100)),
                    child: Text("$msg", style: TextStyle(color: msgType == "facebook" || msgType == "instagram" ? Colors.white:Colors.black),),
                  ),
                  Container(
                    child: Row(
                      children: [
                        Text("${message == null ? "-": DateFormat.jm().format(DateTime.parse(message?['createdAt']))}", style: Styles.p3(fontSize: 9, color: msgType == "facebook" || msgType == "instagram" ? Colors.white: Colors.black.withOpacity(0.5)),),
                      ],
                    ),
                  )
                ],
              ),
            ),
            decoration: BoxDecoration(
                color: msgType == "facebook" ? Color(0xff0084FF) : msgType == "instagram" ? Color(0xff5851DB): Color(0xffE5FDF2),
                borderRadius: BorderRadius.circular(12)
            ),
          )
        ],
      ),
    );
  }
}