import 'package:flutter/material.dart';
import 'package:flutter/src/widgets/framework.dart';
import 'package:flutter/src/widgets/placeholder.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:storebounty_account/widget/constants/constant.dart';
import 'package:storebounty_account/common/styles/textstles.dart';

class EmptyFavs extends StatelessWidget {
  final Color? defaultColor;
  const EmptyFavs({super.key, this.defaultColor});

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        Container(
          height: 400,
          width: 400,
          child: SvgPicture.asset(
            "$kImagePath/fav_empty.svg",
            color: defaultColor?.withOpacity(0.1),
          ),
        ),
        Container(
          margin: EdgeInsets.symmetric(horizontal: 36),
          child: Column(
            children: [
              Text(
                "You have no Favorites",
                style: Styles.h3(),
              ),
              Text(
                "Click on the  favorites icon to add products to your favorite",
                textAlign: TextAlign.center,
                style: Styles.p0(color: Color(0xff7E7E7E)),
              ),
            ],
          ),
        ),
      ],
    );
  }
}
